class MyImgProc
{
  PImage in_img;
  PImage out_img;
  
  MyImgProc(PImage img)
  {
    in_img = img;
    out_img = img;
  }
  
  void grayscale()
  {
    PImage img = createImage(
      out_img.width, out_img.height, RGB );
    
    out_img.loadPixels();
    for ( int y = 0; y < out_img.height; y++)
    {
      for ( int x = 0; x < out_img.width; x++)
      {
        int pos = x + y*out_img.width;
        color c = out_img.pixels[pos];
        float r = red( c );
        float g = green( c );
        float b = blue( c );
        float gray = 0.3 * r + 0.59 * g + 0.11 * b;
        img.pixels[pos] = color(gray);
      }
    }
    img.updatePixels();
    out_img = img;
  }
  
  void contrast(int in_min, int in_max, int out_min, int out_max)
  {
    float[] lut = new float[256];
    for ( int i = 0; i < 256; i++)
    {
      if ( i <= in_min )
      {
        lut[i] = (float)out_min;
      }
      else if ( i >= in_max)
      {
        lut[i] = (float)out_max;
      }
      else
      {
        float d = (float)(out_max - out_min) / 
          (float)(in_max - in_min);
        lut[i] = (i - in_min) * d + out_min;
      }
    }
    
    PImage img = createImage(
      out_img.width, out_img.height, RGB );
      
    out_img.loadPixels();
    for ( int y = 0; y < out_img.height; y++)
    {
      for ( int x = 0; x < out_img.width; x++)
      {
        int pos = x + y*out_img.width;
        color c = out_img.pixels[pos];
        float r = red( c );
        float g = green( c );
        float b = blue( c );
        img.pixels[pos] = 
          color(lut[(int)r], lut[(int)g], lut[(int)b]);
      }
    }
    img.updatePixels();
    out_img = img;    
  }
  
  PImage getInImg()
  {
    return in_img;
  }
  
  PImage getOutImg()
  {
    return out_img;
  }
}


