import gab.opencv.*;

OpenCV opencv;

void setup()
{
  opencv = new OpenCV(this, "sample.jpg");
  size(opencv.width + 290, opencv.height*2 + 30, P2D);
  noLoop();
}

void draw()
{
  background(0); 

  PImage in_img = opencv.getOutput();
  image(in_img, 10, 10, in_img.width, in_img.height);
  
  Histogram inHist = opencv.findHistogram(
    opencv.getGray(), 256);
    
  stroke(125);
  noFill();
  rect(in_img.width + 20, 10, 256, 100);
  
  fill(125);
  noStroke();
  inHist.draw(in_img.width + 20, 10, 256, 100);
  
  OpenCV opencvOut = new OpenCV(this, in_img);
  opencvOut.equalizeHistogram();
  PImage out_img = opencvOut.getOutput(); 
  image(out_img, 10, in_img.height + 20, 
    out_img.width, out_img.height);
    
  Histogram outHist = opencvOut.findHistogram(
    opencvOut.getGray(), 256);
  
  stroke(125);
  noFill();
  rect(out_img.width + 20, in_img.height + 20, 256, 100);
  
  fill(125);
  noStroke();
  outHist.draw(out_img.width + 20, in_img.height + 20, 256, 100);
}
