import gab.opencv.*;

OpenCV opencv;

int LONG_SIDE = 500;
int disp_width = 0;
int disp_height = 0;
int padding_left = 0;
int padding_top = 0;

void setup()
{
  opencv = new OpenCV(this, "sample.jpg", true);
  
  if (opencv.width > opencv.height)
  {
    disp_width = LONG_SIDE;
    float ratio = opencv.width / (float)LONG_SIDE;
    disp_height = (int)(opencv.height * ratio);
    padding_top = (LONG_SIDE - disp_height) / 2;
  }
  else
  {
    disp_height = LONG_SIDE;
    float ratio = opencv.height / (float)LONG_SIDE;
    disp_width = (int)(opencv.width * ratio);
    padding_left = (LONG_SIDE - disp_width ) / 2;
  }
  
  size(LONG_SIDE + 290, LONG_SIDE, P2D);
  noLoop();
}

void draw()
{
  background(0);
  
  Histogram grayHist = opencv.findHistogram(
    opencv.gray(opencv.getColor()), 256);
  Histogram rHist = opencv.findHistogram(opencv.getR(), 256);
  Histogram gHist = opencv.findHistogram(opencv.getG(), 256);
  Histogram bHist = opencv.findHistogram(opencv.getB(), 256);

  PImage in_img = opencv.getInput();
  image(in_img, padding_left + 10, padding_top + 10, 
    disp_width, disp_height);

  stroke(125);
  noFill();  
  rect(LONG_SIDE + 20, 10, 256, 100);
  
  fill(125);
  noStroke();
  grayHist.draw(LONG_SIDE + 20, 10, 256, 100);

  stroke(255, 0, 0);
  noFill();  
  rect(LONG_SIDE + 20, 20 + 100, 256, 100);
  
  fill(255, 0, 0); noStroke();
  rHist.draw(LONG_SIDE + 20, 20 + 100, 256, 100);

  stroke(0, 255, 0); noFill();  
  rect(LONG_SIDE + 20, 30 + 200, 256, 100);
  
  fill(0, 255, 0); noStroke();
  gHist.draw(LONG_SIDE + 20, 30 + 200, 256, 100);

  stroke(0, 0, 255); noFill();  
  rect(LONG_SIDE + 20, 40 + 300, 256, 100);
  
  fill(0, 0, 255); noStroke();
  bHist.draw(LONG_SIDE + 20, 40 + 300, 256, 100);
}
