import gab.opencv.*;
import org.opencv.imgproc.*;
import org.opencv.core.*;

OpenCV opencv;

float ANGLE = -45.0;
float SCALE = 1.0;

void setup()
{
  opencv = new OpenCV(this, "sample.jpg", true);
  size(opencv.width*2, opencv.height, P2D);
  noLoop();
}

void draw()
{  
  Mat src_mat = opencv.getColor();
  Mat dst_mat = new Mat();
  
  Point center = 
    new Point(src_mat.cols()*0.5, src_mat.rows()*0.5);
  Mat affine_matrix = Imgproc.getRotationMatrix2D(
    center, ANGLE, SCALE);
    
  Imgproc.warpAffine(src_mat, dst_mat, affine_matrix,
    src_mat.size());
  
  PImage in_img = opencv.getInput();
  PImage out_img = opencv.getSnapshot(dst_mat);
  image(in_img, 0, 0);
  image(out_img, in_img.width, 0);
}
