import gab.opencv.*;
import org.opencv.imgproc.*;
import org.opencv.core.*;

OpenCV opencv;

void setup()
{
  opencv = new OpenCV(this, "sample.jpg", true);
  size(opencv.width*2, opencv.height, P2D);
  noLoop();
}

void draw()
{
  Mat bgr_mat_in = opencv.getColor();
  
  Mat hsv_mat_in = new Mat();
  Imgproc.cvtColor(bgr_mat_in, hsv_mat_in, 
    Imgproc.COLOR_BGR2HSV);
  ArrayList<Mat> hsv_mat_list = new ArrayList<Mat>();
  Core.split(hsv_mat_in, hsv_mat_list);
  // Hue: get(0), Saturation: get(1), Brightness: get(2)
  hsv_mat_list.get(0).setTo(Scalar.all(20.0));
  hsv_mat_list.get(1).setTo(Scalar.all(64.0));

  Mat hsv_mat_out = new Mat();
  Core.merge(hsv_mat_list, hsv_mat_out);  
  Mat bgr_mat_out = new Mat();
  Imgproc.cvtColor(hsv_mat_out, bgr_mat_out,
    Imgproc.COLOR_HSV2BGR);
  
  PImage in_img = opencv.getInput();
  PImage out_img = opencv.getSnapshot(bgr_mat_out);
  image(in_img, 0, 0);
  image(out_img, in_img.width, 0);
}

