import gab.opencv.*;
import processing.video.*;

Movie video;
OpenCV opencv;

void setup()
{
  size(720*2, 480, P2D);
  video = new Movie(this, "sample.mov");
  opencv = new OpenCV(this, 720, 480);
  
  opencv.startBackgroundSubtraction(5, 3, 0.5);
  
  video.loop();
  video.play();
}

void draw()
{
  image(video, 0, 0);  
  opencv.loadImage(video);
  opencv.updateBackground();
  PImage subFrame = opencv.getOutput();
  image(subFrame, video.width, 0);  
}

void movieEvent(Movie m) {
  m.read();
}
