import gab.opencv.*;
import processing.video.*;
import java.awt.*;

Capture video;
OpenCV opencv;

int SCALE = 2;
int BLUR_SIZE = 16;
int BRIGHTNESS = +64;

void setup()
{
  size(640, 480, P2D);
  video = new Capture(this, 640/SCALE, 480/SCALE);
  opencv = new OpenCV(this, 640/SCALE, 480/SCALE);
  opencv.useColor();
  opencv.loadCascade(OpenCV.CASCADE_FRONTALFACE);  

  video.start();
}

void draw()
{
  scale(SCALE);
  opencv.loadImage(video);
  
  Rectangle[] facesRect = opencv.detect();

  for (int i = 0; i < facesRect.length; i++)
  {
    opencv.setROI(facesRect[i].x, facesRect[i].y,
      facesRect[i].width, facesRect[i].height);
    opencv.blur(BLUR_SIZE);
    opencv.brightness(BRIGHTNESS);
    opencv.releaseROI();
  }
  
  PImage img = opencv.getOutput();
  image(img, 0, 0);
}

void captureEvent(Capture c)
{
  c.read();
}

